#-*-coding:utf-8-*-
"""
    Description des exceptions du gestionnaire de base de données
"""
class AddDBError(Exception):
    """
        Erreur d'insertion , element : élément dont l'insertion a échouée
    """
    def __init__(self, table, element):
        self.element = element
        self.table = table

class DelDBError(AddDBError):
    """
        Erreur de suppression d'élément dans une table
    """
    def __init__(self, table, elementid):
        self.table = table
        self.elementid = elementid

class GetDBError(Exception):
    """
        Erreur de récupération d'élément dans une table de jointure
    """
    def __init__(self, table, element):
        self.table = table
        self.element = element

class AddLinkDBError(Exception):
    """
        Erreur d'ajout de lien dans une table de jointure
    """
    def __init__(self, linktablename, table1, table2, key1, key2, link):
        self.linktable = linktablename
        self.element1 = {'table':table1, 'key':key1, 'id':link[key1]}
        self.element2 = {'table':table2, 'key':key2, 'id':link[key2]}

class DelLinkDBError(AddLinkDBError):
    """
        Erreur de suppression de lien
    """
    pass

class GetLinkDBError(GetDBError):
    """
        Erreur de récupération de lien dans une table de jointure
    """
    def __init__(self, linktablename, table1, table2, key1, key2, link):
        self.linktable = linktablename
        self.element = {'table':table1, 'key':key1, 'id':link[key1]}

class ModDBError(AddDBError):
    """
        Erreur de modification d'entrée dans la base
    """
    def __init__(self, table, elem_id, modkeys):
        self.table = table
        self.element_id = elem_id
        self.modkeys = modkeys
