#-*-coding:utf-8-*-
from os.path import join, dirname, normpath
from creole import parsedico
dico = parsedico.parse_dico()

HERE = dirname(__file__)
LOCAL_DIR = normpath(join(HERE, '..'))
# path vers les scripts du module posh
SCRIPT_PATH = '/usr/share/xmlrpc-posh'

# PERMISSIONS:
# fichier de permission: lie les onglets à des profiles
perm_filename = join(LOCAL_DIR, 'perm', 'data', 'perm.ini')

# fichier de profile : lie des users à des profiles via leurs attributs
profile_filename = join(LOCAL_DIR, 'perm', 'data', 'profiler.ini')

# Path vers le serveur de profile et l'interface d'admin
LOCATION = "/usr/share/xmlrpc-posh/"

# IP_LOCALE:
LOCAL_IP = dico['adresse_ip_eth0']
# XMLRPC:
# Port et adresse du serveur xmlrpc utilisé pour la configuration utilisateur
XMLRPC_PORT=int(dico.get('posh_xmlrpc_port', '7080'))
XMLRPC_IP_SERVER=dico.get('posh_xmlrpc_ip', 'localhost')

# Port de l'interface d'administration html
ADMIN_PORT=int('7070')
#timeout de la session de l'interface en 12 min si pas d'action
SESSION_TIMEOUT = 12 * 60

# Script de récupération des infos de la BDD Posh pour le client xmlrpc
INFO_FILE = join(SCRIPT_PATH, 'utils', "dbinfo.php")

profile_db_pwd="posh"
profile_db_config = {'host':'localhost', 'user':'posh','passwd':profile_db_pwd, 'db':'poshprofile'}

# adresse du serveur sso:
ip_sso = dico.get('posh_cas_ip', dico.get('adresse_ip_sso', '1.1.1.1'))
port_sso = dico.get('posh_cas_port', dico.get('port_sso', 443))
AUTH_FORM_URL = "https://%s:%s/" % (ip_sso, port_sso)
AUTH_SERVER = "https://%s:%s/xmlrpc" % (ip_sso, port_sso)

# INITTHUMBS LOGS :
LOGS_INITTHUMB = "/var/log/posh/initthumb.log"

