#-*-coding:utf-8-*-
from posh.thumbs.initthumbs import DB
TABQUERY = "SELECT name,seq,type,param,id FROM profile WHERE user_id=%s AND id=%s "

class ExportThumbs(DB):
    """ exportateur d'onglet """

    def __init__(self, username, user_id, thumb_id, thumb_name, thumb_indice, xmlrpc_server, myip, mykey):
        """
            user_id : id de l'utilisateur admin dans la base
            thumb_id : id de l'onglet dans la base
        """
        super(ExportThumbs, self).__init__()
        self.username = username
        self.user_id = user_id
        self.thumb_id = thumb_id
        self.thumb_name = thumb_name
        self.thumb_indice = thumb_indice
        self.server = xmlrpc_server
        self.myip = myip
        self.mykey = mykey

    def _get_thumb(self):
        """
            renvoie les données liées à l'onglet à exporter
        """
        self.connect_db()
        query = TABQUERY % (self.user_id, self.thumb_id)
        self.db.query(query)
        rows = self.db.store_result()
        tab = list(rows.fetch_row(0))
        self.close_db()
        result = list(tab[0])
        # si l'indice doit être modifié
        try:
            if int(self.thumb_indice) >= 0:
                result[1] = self.thumb_indice
        except:
            print "WARNING : On essaye d'insérer un onglet dont l'indice n'est pas un nombre."
        # on insère le nom pour dans la table de profil
        result.insert(0, self.thumb_name)
        return result

    def export_thumb(self):
        """
            exporte un onglet
        """
        return self.server.export_thumb(self.username, self.myip, self.mykey, self.thumb_name, self._get_thumb())
