#-*-coding:utf-8-*-
"""
    outil de gestion des onglets pour posh

    récupère les onglets auprès du gestionnaire de profil
    les compare aux onglets métiers déjà écrits dans la base
    pour cet utilisateur et rajoute ceux qui manquent

    gère également les modules
"""

import sys
#FIXME: utilisation de subprocess
import commands
from os.path import join
import MySQLdb
from sets import Set

from posh.perm.rule import Thumb, Module
from posh.config.config import INFO_FILE, LOGS_INITTHUMB

# nom des champs de la table profile, les 4 premiers viennent des profils
# cacheurl=tag les onglets métiers (valeur=metier au lieu de unused)
# pass = stockage du 'name' de l'onglet dans le gestionnaire de profile
# user_id et id = id utilisateur et id de l'onglet dans la base
fields = """pass name seq type param user_id id cacheurl width height""".split()

# id de l'utilisateur admin dans la base posh
id_admin = "2"
# syntaxe sql
# recupère l'user_id d'un user
USER_ID_QUERY = "SELECT id FROM users WHERE username='%s'"
# recuperation des onglets de l'utililsateur
GETTAB_QUERY = "SELECT * FROM profile WHERE user_id=%s ORDER BY seq"
# recuperation des onglets métiers de l'utililsateur
GETSPECTAB_QUERY = "SELECT * FROM profile WHERE user_id=%s and cacheurl='metier' ORDER BY seq"
# recuperation des onglets dont le seq est supérieur à un seq donné
SELECT_SEQ_QUERY = "SELECT * FROM profile WHERE user_id='%s' and seq>=%s ORDER BY seq"
# insertion d'un élément
INSERTTAB_QUERY = "INSERT INTO profile (%s) VALUES (%%s)" % ','.join(fields)
# mise à jour d'un onglet
UPDATETAB_QUERY = "UPDATE profile SET seq='%s' WHERE user_id='%s' and id='%s' and name='%s'"
# recuperation d'un id de la table profile posh depuis une entrée du gestionnaire de profil
GET_THUMBID = "SELECT id FROM profile WHERE user_id='%s' and name='%s' and cacheurl='metier'"

# GESTION DES WIDGETS (ou modules):
# de l'administrateur
ADMIN_THUMB_MODULES_QUERY = "SELECT * FROM module WHERE user_id='%s' and profile_id='%%s'" % id_admin
# récupération des modules écrits par ce programme et de ceux intercalés par l'utilisateur
USER_PROFILED_THUMB_MODULES_QUERY = "SELECT * FROM module WHERE user_id='%s' and profile_id='%%s' and typ='m'"
USER_PERSO_THUMB_MODULES_QUERY =  "SELECT * FROM module WHERE user_id='%s' and profile_id='%%s' and typ!='m'"

# Insertion de modules dans une page
module_fields = """item_id user_id profile_id posx posy posj x y typ variables uniq blocked minimized""".split()

INSERTMODULE_QUERY = "INSERT INTO module (%s) VALUES (%%s)" % ','.join(module_fields)
UPDATE_ID_MODULE = "UPDATE module SET uniq='%s' WHERE user_id='%s' and profile_id='%s' and uniq='%s'"
UPDATE_MODULE = "UPDATE module SET item_id='%s',variables='%s' WHERE user_id='%s' and profile_id='%s' and uniq='%s'"



debug = False
morelog = False

def encoding(query):
    try:
        a = query.decode('utf-8')
        a = a.encode('ISO-8859-15')
        return a
    except:
        return query

def decoding(result):
    return result.encode('utf-8')
    try:
        result = result.decode('ISO-8859-15')
        result = result.encode('utf-8')
    except:
        return result

def fdebug(msg):
    a = file(LOGS_INITTHUMB, "a")
    a.write(msg)
    a.write('\n')
    a.close()

def get_dbinfos():
    """
        renvoie les paramètres de connexion à la base mysql du portail
    """
    php_script = INFO_FILE
    code, result = commands.getstatusoutput("/usr/bin/php %s" % php_script)

    if code:
        fdebug("Exception, 'Erreur à la récupération des infos de BDD'")
    host, user, passwd, db = map(lambda x:x.strip(), result.split(','))
    datas = dict(host=host,
                user=user,
                passwd=passwd,
                db=db)
    return datas

class DB(object):
    """
        gestionnaire de base de données
    """
    def __init__(self):
        self.dbinfos = get_dbinfos()

    def connect_db(self):
        self.db = MySQLdb.connection(**self.dbinfos)

    def close_db(self):
        self.db.close()

    def _insert(self, template, query_list, connect=True):
        """ insert un élément dans la base selon le template"""
        # formattage
        join_func = lambda x:"'%s'" % MySQLdb.escape_string(str(x))
        insert_args = ','.join(map(join_func, query_list))
        insert_query = encoding(template % insert_args)
        # requete
        fdebug("Mysql Cmd = Insert : %s" % insert_query)
        if connect:
            self.connect_db()
        self.db.query(insert_query)
        if connect:
            self.close_db()

    def _update(self, template, query_list, connect=True):
        """ update un élément de la base selon le template
        """
        # formattage
        if type(query_list) is not list:
            query_list = list(query_list)
        query_list = tuple([MySQLdb.escape_string(str(x)) for x in query_list])
        update_query = encoding(template % query_list)
        # requete
        fdebug("Mysql Cmd = Update : %s" % update_query)
        if connect:
            self.connect_db()
        self.db.query(update_query)
        if connect:
            self.close_db()

    def _query(self, template, query_list, connect=True):
        """ éxécute une requête et renvoie le résultat
            connect : connection à la base avant requeête
        """
        # formattage
        if not hasattr(query_list,'__iter__'):
            query_list = [query_list]
        query_list = tuple([MySQLdb.escape_string(str(x)) for x in query_list])
        query = encoding(template % query_list)
        # requete
        fdebug("Mysql Cmd = Query : %s" % query)
        if connect:
            self.connect_db()
        self.db.query(query)
        rows = self.db.store_result()
        result = list(rows.fetch_row(0))
        result = [list(a) for a in result]
        if connect:
            self.close_db()
        return result

class InitThumbs(DB):
    """
        gestionnaire de profil
        Récupère les descriptions des onglets en fonction des infos user
        écrit dans la table

        Dans la base:
            seq: ordre des onglets
            id: id de l'onglet (par utilisateur)
        @user_datas : informations de l'utilisateur provenant du serveur SSO
                      voir configuration du serveur SSO
        Un onglet c'est :
            - un user_id
            - une position (ordre des onglets)
            - un libelle
            - une icone         (facultative)

            - un type de page   (avec widget, url)
            - une url
    """
    # requête pour la récupération des onglets:
    def __init__(self, user_datas, username=None, xmlrpc_server=None):#, usercontext=None):
        """
            @user_datas : dictionnaire décrivant les données de l'utilisateur
                          en cours de connexion
        """
        fdebug("**** Initialisation de InitThumbs : username : %s" % username)
        fdebug('**** Initialisation de InitThumbs : user_datas : %s' % user_datas)
        super(InitThumbs, self).__init__()
        if user_datas.has_key('infos'):
            self.user_datas = user_datas['infos']
        else:
            self.user_datas = user_datas

        if username == None:
            self.username = user_datas['infos']['uid'][0]
        else:
            if type(username) == list: username=username[0]
            self.username = username
        self._get_user_id()
        self.server = xmlrpc_server

    def _get_user_id(self):
        """
            récupère l'user_id de l'utilisateur
            dans la base à l'aide des données utilisateurs
        """
        uid = self.username
        self.user_id = self._query(USER_ID_QUERY, uid)[0][0]

## onglets internes et externes
    def _get_user_inttabs(self):
        """onglets internes à l'utilisateur
            (ceux résultant du querry de la db posh)
        """
        result = self._query(GETSPECTAB_QUERY, self.user_id)
        thumbs = Set()
        for row in result:
            thumbs.add(Thumb(name=str(row[9]), description=str(row[2]), seq=str(row[1]), _type=str(row[20]), param=str(row[25])))
        return thumbs

    def _get_user_exttabs(self):
        """
            renvoie les onglets externes de l'utilisateur
            ('onglets métiers')
            en fonction de son profil
            Profile --user_datas--> gestion de profil --profil--> gestion d'onglet --onglet--> Profile
        """
        external_thumbs = [Thumb(*thumb) for thumb in self.server.get_thumbs(self.username, self.user_datas)]
        external_thumbs = self._set_all_seqs(external_thumbs)
        return Set(external_thumbs)

## insertion des onglets dans la base
    def _get_insert_tabs(self, ext_thumbs):
        """collecte les onglets des utilisateurs (internes et externes)
            c'est le complémentaire d'une différence symétrique

            attention, si 2 onglets interne et externe sont identiques niveau objet,
            il ne le sont pas forcément au niveau de 'tout' les attributs de l'objet
            donc ext.symmetric_difference(int) != int_thumbs.symmetric_difference(ext_thumbs)
            l'un renvoie les éléments de ext_thumbs, l'autre ceux de int_thumbs
            l'ext_thumb contient l'attribut admin_profile_id pas un int_thumb

        int = onglets internes
        ext = onglets externes
        sd = ext.symmetric_difference(int)
        ensuite on prend le complémentaire de sd par rapport à int

        """
        int_thumbs = self._get_user_inttabs()
        sd = ext_thumbs.symmetric_difference(int_thumbs)
        return sd.difference(int_thumbs), ext_thumbs.intersection(int_thumbs)

    def _get_thumb_id(self, thumb):
        """ recupère l'id d'un onglet dans la table profile de posh """
        return self._query(GET_THUMBID,[self.user_id, thumb.description])[0][0]

    def insert_tabs_and_modules(self):
        """
            1 - insertion des onglets extérieurs (provenant du gestionnaire de profil)
                les onglets peuvent pointer vers une url externe ou contenir des widgets
            2 - insertion et mise à jour des widgets
        """
        try:
            # recupérons l'id suivant dans la base profile de posh
            result = self._query(GETTAB_QUERY, self.user_id)
            next_id = self._next_id(result)

            # récupération des onglets extérieurs (du gestionnaire de profil)
            ext_thumbs = self._get_user_exttabs()

            # Onglets à insérer
            tabs_to_insert = list(self._get_insert_tabs(ext_thumbs)[0])
            # Onglets déjà dedans
            already_in = self._get_insert_tabs(ext_thumbs)[1]
            if morelog:
                fdebug('+++ already')
                for i in already_in:
                    fdebug("%s : %s"%(str(i.name), str(i.admin_profile_id)))
                fdebug('+++ toinsert')
                for i in tabs_to_insert:
                    fdebug("%s : %s"%(str(i.name), str(i.admin_profile_id)))

            # mise à jour des séquences
            for thumb in tabs_to_insert:
                fdebug("+++ Onglet à insérer : %s" % thumb.name)
                 # ajout de param à l'onglet pour son écriture dans la base
                _thumb = self._update_thumb(thumb.to_dbfield(), next_id)
                # insertion d'onglet
                try:
                    user_profile_id = self.insert_field(_thumb,next_id)
                except Exception, msg:
                    fdebug("--- Erreur lors de l'insertion d'onglet dans la base : %s" % msg.message)
                # insertion des widgets
                try:
                    # next_id est l'id de la page (onglet) dans la base profile
                    # il est utilisé pour lier la page à ses modules
                    self.set_user_modules(thumb, next_id)
                except Exception, msg:
                    fdebug("--- Erreur lors de l'écriture des widgets de la page %s : %s" % (thumb.name, str(msg.message)))
                next_id += 1

            # insertion/mise à jour  des widgets
            try:
                self.update_user_modules(already_in)
            except Exception, msg:
                fdebug("--- Erreur lors de la mise à jour des widgets :\n %s" % (str(msg.message)))
            fdebug("----> Fin de l'insert Tabs and modules\n")
        except Exception, msg:
            fdebug(" Problème à l'insertion d'onglet dans insert_tabs_and_modules %s " % msg.message)
            fdebug(str(msg))


    def insert_field(self, thumb, next_id):
        """ insertion d'un onglet dans le profil de l'utilisateur
        """
        seq = thumb[2]
        result = self._query(SELECT_SEQ_QUERY , [self.user_id, seq])
        self.connect_db()
        # on met à jour les séquences des onglets au milieu desquels on veut intercaler
        if str(seq) in [row[20] for row in result]:
            for row in result:
                new_tab_seq = int(row[20])+1
                self._update(UPDATETAB_QUERY, [new_tab_seq, row[0], row[1], row[2]], connect=False)
        # on insert
        self._insert(INSERTTAB_QUERY , thumb, connect=False)
        self.close_db()

    ### insertion de modules dans la base
    def set_user_modules(self, thumb, user_profile_id):
        """ définit les modules de l'utilisateur depuis ceux de la page de l'admin
            pour une page avec widgets
            user_profile_id : id de l'onglet dans la table de l'utilisateur
        """
        if self.is_widget_thumb(thumb.admin_profile_id):
            admin_modules = self._get_user_thumbs_modules(thumb.admin_profile_id)
            self.connect_db()
            for module in admin_modules:
                self._insert_module(module, user_profile_id)
            self.close_db()

    ## update des modules dans la base
    def update_user_modules(self, thumbs):
        """ met à jour les modules des pages du user """
        for thumb in thumbs:
            fdebug("+++ Onglets déjà dedans : %s" % (thumb.name))
            # on update les widgets de la page
            if self.is_widget_thumb(thumb.admin_profile_id):
                fdebug('++ Update des widgets de %s' % thumb.name)
                self._update_user_module(thumb, self._get_thumb_id(thumb))

    def _update_user_module(self, thumb, user_profile_id):
        """ met à jour les modules de l'utilisateur pour une page avec widget
            user_profile_id : id de l'onglet dans la table de l'utilisateur
        """
        admin_modules = self._get_user_thumbs_modules(thumb.admin_profile_id)
        usr_modules = self._get_user_thumbs_modules(user_profile_id, admin=False)
        perso_modules = self._get_user_thumbs_modules(user_profile_id, admin=False, personnal=True)

        self._set_modified_modules(admin_modules, usr_modules, perso_modules, user_profile_id)

    def _set_modified_modules(self, admin_modules, usr_modules, perso_modules, profile_id):
        """
        """
        # on transforme les listes de modules en dico avec l'id uniq comme clé
        adm_dict_modules = dict([(mod[10], mod) for mod in admin_modules])
        usr_dict_modules = dict([(mod[10], mod) for mod in usr_modules])
        usr_pers_dict_modules = dict([(mod[10], mod) for mod in perso_modules])
        self.connect_db()
        for key, value in adm_dict_modules.items():
            if key in usr_dict_modules: # cas où le module a déjà été écrit dans la table du user
                if morelog: fdebug("  ++ Widget déjà présent")
                cmp = Module(value) == Module(usr_dict_modules[key])
                if not cmp:
                    self._update_module(value, profile_id, key)

            elif key in usr_pers_dict_modules: # cas où un module perso a déjà le même id
                if morelog : fdebug("  ++ Widget pas présent mais un widget personnel a le même id")
                # modification de l'id du module perso pour pouvoir mettre le module imposé à la place
                new_id = self._next_module_id(adm_dict_modules.keys(), usr_dict_modules.keys(), usr_pers_dict_modules.keys())
                self._update_module_id(new_id, profile_id, key)
                # insertion de l'onglet imposé
                self._insert_module(value, profile_id)
            else: # cas où le module imposé va être écrit
                if morelog: fdebug("  ++ Widget non présent dans la config du user")
                to_insert = self._insert_module(value, profile_id)
        self.close_db()

    def _update_module(self, module, profile_id, uniq):
        """ met à jour l'entrée dans la base module pour l'élément module
        """
        try:
            # on update les champs item_id et variables
            item_id, variables = module[0], module[9]
            self._update(UPDATE_MODULE, [item_id,variables, self.user_id, profile_id, uniq], connect=False)
        except Exception, msg:
            fdebug("--- ERREUR initthumbs.py : _update_module , erreur à l'update du module : \n      %s" % msg.message)

    def _update_module_id(self, new_id, profile_id, uniq):
        """ met à jour l'id du module d'un utilisateur """
        try:
            self._update(UPDATE_ID_MODULE, [new_id, self.user_id, profile_id, uniq], connect=False)
        except Exception, msg:
            fdebug("--- ERREUR initthumbs.py : _update_module_id, erreur à l'update de l'id du module : \n      %s" % msg.message)

    def _insert_module(self, module, profile_id):
        """ insert un module dans la page d'id profile_id """
        try:
            to_insert = self._make_it_a_user_module(module, profile_id)
            self._insert(INSERTMODULE_QUERY, to_insert, connect=False)
        except Exception, msg:
            fdebug("--- ERREUR initthumbs.py : _insert_module , erreur à l'insertion d'un onglet dans la base : %s" % msg.message)

    def _make_it_a_user_module(self, listmodule, user_profile_id):
        """ adapte une entrée de la table module à un utilisateur
        """
        listmodule[1] = self.user_id
        listmodule[2] = user_profile_id
        # utilisation d'une entrée de table inutilisée
        # pour tagger les modules imposés
        listmodule[8] = 'm'
        return listmodule

    def _get_user_thumbs_modules(self, user_profile_id, admin=True, personnal=False):
        """ récupère les modules liés à un onglet d'id user_profile_id,
            dans la base module de posh
            si admin on cherche chez l'admin sinon on utilise l'id de
            l'utilisateur courant pour chercher ses onglets profilés
            si personnal, on prend les onglets perso de l'utilisateur
        """
        if personnal: tmpl = USER_PERSO_THUMB_MODULES_QUERY % self.user_id
        elif admin: tmpl = ADMIN_THUMB_MODULES_QUERY
        else: tmpl = USER_PROFILED_THUMB_MODULES_QUERY % self.user_id

        return self._query(tmpl, str(user_profile_id))

    ## méthodes utiles

    def _next_id(self, tabs):
        """
            renvoie un id d'onglet disponible (le plus grand +1)
        """
        highest = 1
        for tab in tabs:
            if highest < int(tab[1]):
                highest = int(tab[1])
        return highest +1

    def _next_module_id(self, a, b, c):
        a.extend(b)
        a.extend(c)
        return int(max(a)) + 1

    def _set_all_seqs(self, thumbs):
        """ ordonne les seqs des onglets métiers
            ex : si on  a un thumb avec un seq 1 et un autre avec le seq 3, on veut 1 et 2
        """
        def sorting_seqs(thumba, thumbb):
            if thumba.seq > thumbb.seq:
                return 1
            elif thumba.seq == thumbb.seq:
                return 0
            else:
                return -1
        thumbs.sort(sorting_seqs)
        for thumb in thumbs:
            thumb.seq = thumbs.index(thumb)
        return thumbs

    def _update_thumb(self, thumb, next_id):
        """ ajoute des parametres au thumb
            user_id, next_id, le tag pour l'onglet métier,
            les tailles de la matrice de position pour le cas où c'est des pages avec widget
        """
        thumb = thumb[:5] # on sort le admin_profile_id qui ne sert que pour la recuperation d'éventuel widget
        thumb.append(self.user_id)
        thumb.append(next_id)
        thumb.append('metier')
        thumb.append('3')
        thumb.append('5')
        return thumb

    def _get_admin_profile_id(self, thumb):
        """
            renvoie l'id de l'onglet pour l'admin dans la table profile de posh
            valable pour un onglet avec widget
        """
        if _type(thumb) == list:
            return thumb[5]
        else:
            return thumb.admin_profile_id

    def is_widget_thumb(self, _id):
        return int(_id) > 0

    def update_seq(self, thumbs):
        pass

def main(user_datas):
    # profile = Profile(user_datas)
    # profile.init_tabs()
    thumbs_manager = InitThumbs(user_datas)
    thumbs_manager.insert_tabs()

if __name__ == '__main__':
    if debug:
        user_datas = {'infos': {'uid': ['anna.verkerk'],
                              'typeadmin': ['2'],
                              'user_groups': ['professeurs',
                                            'profs-5e1',
                                            'profs-5e2',
                                            'profs-5e3',
                                            'profs-3e1',
                                            'maths',
                                            'idaut',
                                            'domainusers',
                                            'groupe-test',
                                            'gr-testtime'],
                              'user': ['anna.verkerk'],
                              'homedirectory': ['/home/a/anna.verkerk'],
                                'cn': ['ANNA CATHA VERKERK']}
                     }
        main(user_datas)
    else:
        import sys
        import json
        try:
            user_datas = sys.argv[1]
            json.decode(user_datas)
            main(user_datas)
        except:
            fdebug( "Erreur de recuperation des infos utilisateurs")
