#-*-coding:utf-8-*-
"""
    librairie de construction des données pour les balises html
"""
# libellés pour le menu
menu_libelles = {'profilethumb':"Autoriser des onglets",
                 "profiledesktopitem":"Autoriser des items de bureau",
                 "userattrprofile":"Définir des rôles",
                 "profile":"Profil utilisateur",
                 "thumb":"Onglet",
                 "desktopitem":"Item de bureau",
                 "userattr":"Attribut utilisateur",}
# description des clés des tables (à voir si plusieurs tables ont des clés du même nom, faudra classer par table)
keys_libelles = {
            'name': "Nom",
            "poshtype":'type de page (2 pour url)',
            "libelle":"libellé",
            "icon":"url de l'icône",
            "attrname":"Nom de l'attribut (nom de la clé ldap par exemple)",
            "attrvalue":"Valeur de l'attribut",
            'admin_profile_id': "Id admin de l'onglet",
            }
# libellés d'une entrée d'une table
element_libelles = {# les tables
                    "profile":"Le profil %(name)s (%(description)s)",
                    "thumb": "L'onglet %(name)s pointant vers : %(url)s",
                    "userattr":"L'attribut utilisateur %(attrname)s de valeur %(attrvalue)s",
                    "desktopitem": "L'item de bureau %(name)s ( %(libelle)s) pointant vers %(url)s",
                    "default":"dans %(tablename)s de %(description)s",
                    }
# Titres des formulaires
form_titles = {
                "profile": "Ajout de profil",
                "thumb":"Ajout d'onglet",
                "desktopitem":"Ajout d'item de bureau",
                "userattr":"Ajout d'attribut utilisateur",
                "userattrprofile":"Lier des profils à des attributs utilisateurs",
                "profilethumb": "Lier des onglets à des profils",
                "profiledesktopitem": "Lier des items de bureau à des profils"
                }

# décrit le libellé des entrées pour une option d'une balise select
select_options_tmpls = {"default":{"value":"%(id)s", "libelle":"%(name)s",
                                    "default":{"value":"0", "libelle":"Choisissez un élément"}},
                        "profile":{"value":"%(profileid)s", "libelle":"%(name)s",
                                  "default":{"value":"0", "libelle":"Choisissez un profil"}},
                        "userattr":{"value":"%(userattrid)s", "libelle":"%(attrname)s de valeur %(attrvalue)s",
                                    "default":{"value":"0", "libelle":"Choisissez un attribut"}},
                        "desktopitem":{"value":"%(desktopid)s", "libelle":"%(name)s",
                                    "default":{"value":"0", "libelle":"Choisissez un item de bureau"}},
                        "thumb":{"value":"%(thumbid)s", "libelle":"%(name)s",
                                    "default":{"value":"0", "libelle":"Choisissez un onglet"}},
                        }
# décrit le titre des selects pour l'édition de table de jointure
# éléments disponibles
available_libelle = {'profile':'Profils disponibles',
                     'thumb': 'Onglets disponilbles',
                     'desktopitem':'Item de bureau disponibles',
                     'default':'%(table)s disponibles',
                    }
# éléments déjà liés
linked_libelle2 = {'profile':'Profils associés',
                  'thumb':'Onglets associés',
                  'desktopitem':'Items de bureau associés',
                  'default' : 'Éléments %(table)s associés',
                  }
# nom des tables
linked_libelle1 = {"userattr":"à l'attribut utilisateur",
                   "profile" : "au profil",
                   "default" : "à un élément de %(table)s",}

def get_available_libelle(tablename):
    return available_libelle.get(tablename, available_libelle['default'] % ({'table':tablename}))

def get_linked_libelle(table1, table2):
    return "%s %s" % (linked_libelle2.get(table2, linked_libelle2['default'] % ({'table':table2})),
                      linked_libelle1.get(table1, linked_libelle1['default'] % ({'table':table1})))

def get_key_libelle(dbkey):
    """
        renvoie le libellé pour un clé utilisateur
    """
    return keys_libelles.get(dbkey, dbkey).capitalize()

def _input(dbkey):
    """ renvoie les données pour écrire un input
    """
    libelle = get_key_libelle(dbkey)
    return {'name':dbkey, 'libelle':libelle}

def form_title(_type):
    """renvoie le titre du formulaire pour le type _type
    """
    return form_titles.get(_type, "Ajouter")

def format_bdd_entry(values):
    for value in values:
        for key, val in value.items():
            if 'None' == val:
                value[key] = 'quelconque'
    return values


def choice_select(_type, values, current=None):
    """
        formatte les valeurs values de la table _type
        pour la mise en forme d'option de balise select
        pour chaque élément créer un dico avec les clés:
        libelle : value[idkey]
        value: tmpls % value
        current : élément en cours d'édition
    """
    tmpl = select_options_tmpls.get(_type, select_options_tmpls['default'])
    values = format_bdd_entry(values)
    values = [{'libelle':tmpl['libelle'] %value,
                    'value':tmpl['value'] % value}for value in values]
    values.insert(0, tmpl['default'])
    if current:
        for value in values:
            if value['value'] == current:
                value['selected'] =  'true'
                break
    return values

def transfer_select(_type, values):
    """
        formatte les valeurs de la table _type pour la mise en forme
        d'option pour les transferts de liste à liste
    """
    tmpl = select_options_tmpls.get(_type, select_options_tmpls['default'])
    values = format_bdd_entry(values)
    return [{'libelle':tmpl['libelle'] % value,
            'value':tmpl['value'] % value} for value in values]

def get_select_option_libelles(_id, items):
    """
        renvoie les libellés des entrées d'id ids
        items = [{'value':id1 'libelle':name1, ...
        et ids : [id1,id2...]
    """

    return [item['libelle'] for item in items if item['value'] == _id]

def menu(tablelist):
    """
        formatte les données de la table pour la présentation
    """
    return [{'name':name, 'libelle':menu_libelles.get(name, name)}
                                for name in tablelist]

#Message de validation
def valid_add_msg(tablename, valid_dict):
    """ renvoie le message d'ajout d'un élément de la table
    """
    if element_libelles.has_key(tablename):
        return {'libelle':element_libelles[tablename] % valid_dict +\
                " a été rajouté dans la base.",
                'font':'bold'}
    else:
        valid_dict['tablename'] = tablename
        return {'libelle': "Ajout " +\
                            element_libelles['default'] % valid_dict,
                "font":'bold'}

def valid_mod_msg(tablename, valid_dict):
    if element_libelles.has_key(tablename):
        return {'libelle':element_libelles[tablename] % valid_dict +\
                " a été modifié dans la base.",
                "font":"bold"}

def add_error_msg(tablename, data):
    """
        formatte le message d'erreur d'insertion dans une table
    """
    if element_libelles.has_key(tablename):
        libelle = element_libelles[tablename].lower() % data
    else:
        libelle = "%s dans %s" % (tablename, data)
    return {'libelle': "Erreur d'ajout: %s n'a pas pu être inséré." % libelle,
            'font':'bold'}

def valid_del_msg(tablename, deleted):
    """ renvoie le message de supression d'un élément de la table
    """
    if element_libelles.has_key(tablename):
        for item in deleted:
            yield {'libelle': element_libelles[tablename] % item +\
                             " a été retiré de la base."}
    else:
        for item in deleted:
            item['tablename'] = tablename
            yield {'libelle': "Suppression " +\
                               element_libelles['default'] % item}

def del_error_msg(tablename, data):
    """
        formatte le message d'erreur de suppression dans une table
    """
    if element_libelles.has_key(tablename):
        libelle = element_libelles[tablename].lower() % data[0]
    else:
        libelle = "%s dans %s" % (tablename, data)
    return {'libelle': "Erreur de suppression: %s n'a pas pu être supprimé." % libelle,
            'font':'bold'}

def mod_error_msg(tablename, data):
    """
        formatte le message d'erreur de modification dans une table
    """
    if element_libelles.has_key(tablename):
        libelle = element_libelles[tablename].lower() % data
    else:
        libelle = "%s dans %s" % (tablename, data)
    return {'libelle': "Erreur de modification : %s n'a pas pu être modifié." % libelle,
            'font':'bold'}
