# -*- coding: utf-8 -*-
from os.path import join

from nevow.rend import Page
from nevow import loaders, tags as T, inevow


from interface.interface.frags.message import Message
from interface.interface.data_handler import datas, valid
from interface.interface.tools import _get_root_url
from interface.interface.config import HTML_DIR


class ValidAddForm(Message):
    """
        fragment de validation d'ajout d'entrée dans la base de données
    """
#    docFactory = loaders.xmlfile(join(HTML_DIR, 'validaddform.xml'))
    close_btn_code = "Refresh('listform_widget');Refresh('linkform_widget');\
            setContent('popup_container','');";
    isLeaf=True

    def __init__(self, _type, type_datas={}):
        self._type = _type
        self.type_datas = type_datas
        super(ValidAddForm, self).__init__()

    def locateChild(self, ctx, segments):
        return self, ()

    def data_message(self, ctx, data):
        """
            valide le formulaire d'ajout
        """
        request = inevow.IRequest(ctx)
        valid_dict = {}
        for attribut in self.type_datas['balises']:
            key = attribut['name']
            if key not in request.args.keys():
                raise Exception, "Il manque des données pour l'ajout de %s" % self._type
            else:
                valid_dict[key] = request.args[key][0]
        return valid.add(self._type, valid_dict)


class AddForm(Page):
    """
        fragment pour la page de formulaire d'ajout
        d'entrée dans la base de données
    """
    docFactory = loaders.xmlfile(join(HTML_DIR, 'addform.xml'))
    children = {'valid': ValidAddForm}
    valid_url = ['add', "valid/?addform=%s"]

    def locateChild(self, ctx, segments):
        request = inevow.IRequest(ctx)
        child, remainingSegments = Page.locateChild(self, ctx, segments)
        if request.args.has_key('addform'):
            self._type = request.args['addform'][0]
        else:
            raise Exception, "Erreur"
        self.form_datas = datas.add_form(self._type)
        if child:
            if child != self:
                return child(self._type, self.form_datas), remainingSegments
        return self, ()

    def _get_valid_url(self, ctx):
        """ renvoie l'url de validation
        """
        return join(_get_root_url(ctx), *self.valid_url) % self._type

    def render_valid_btn(self, ctx, data):
        """ valide le formulaire
        """
        return T.input(_type='submit')

    def render_cancel_btn(self, ctx, data):
        """
            annule l'ajout d'item
        """
        return T.a(href=_get_root_url(ctx))["Annuler"]

    def render_attr_slots(self, ctx, data):
        """
            renvoie les données pour remplir les slots:
            formname : nom du formulaire
            title : titre du formulaire
        """
        ctx.fillSlots('valid_url', self._get_valid_url(ctx))
        ctx.fillSlots('formtitle', self.form_datas['title'])
        ctx.fillSlots('formname', self.form_datas['name'])
        ctx.fillSlots('valid_libelle', 'Validez')
        ctx.fillSlots('valid_id', "submit_%s" % self.form_datas['name'])
        ctx.fillSlots('cancel_libelle', 'Annuler')
        ctx.fillSlots('cancel_url', _get_root_url(ctx))
        return ctx.tag

    def data_forminputs(self, ctx, data):
        """
            renvoie les descriptions de balise
            pour le remplissage des slots de la séquence basée
            sur les datas forminputs
        """
        return self.form_datas['balises']

