# -*- coding: utf-8 -*-
from nevow.rend import Fragment
from nevow import loaders
from os.path import join
from interface.interface.config import HTML_DIR
from interface.interface.tools import _get_root_url
from interface.interface.data_handler import datas
from interface.interface.frags.scrollmenu import ScrollMenuManager

class Menu(Fragment):
    """
        menu d'entête de la page
    """
    docFactory = loaders.xmlfile(join(HTML_DIR, 'menu.xml'))

    def data_scroll_menu(self, ctx, data):
        """ renvoit les datas pour les constructions des fenêtres """
        LINKURL = join(_get_root_url(ctx), 'link')
        ADDURL = join(_get_root_url(ctx), 'add')
        LISTURL = join(_get_root_url(ctx), 'list')
        ICONURL = join(_get_root_url(ctx), 'icone')
        data = []
        menu1 = [ ['Permission', 'Gérer les autorisations'], [
            [table['libelle'],
            "javascript:callUrl('%s',[], 'content_container');" % join(LINKURL, "?linkform=%s" % table['name']),
            table['libelle']]for table in datas.link_menu()]
          ]
        ADDURL = join(_get_root_url(ctx), 'add')

        entete2 = ['Ajout de paramètres', "Ajout de paramètre pour les permissions"]
        items2 = [[table['libelle'],
                  "javascript:callUrl('%s',[], 'popup_container');" % join(
                                     ADDURL, "?addform=%s" % table['name']),
                  table['libelle']]for table in datas.add_menu()]
        # items specifiques (non integrees dans la chaine bdd - interface)
#        items2.append(['Télécharger une icône',
#                      "javascript:fenetre('%s', 'Icon upload');" % ICONURL,
#                      "Télécharger une icône pour l'application desktop"])
#
        menu2 = [ entete2, items2]
        menu3 = [ ['Modification / Suppression', 'Supprimer ou modifier des éléments'],[
                  [table['libelle'],
                    "javascript:callUrl('%s',[], 'content_container');" % join(LISTURL, "?listform=%s" % table['name']),
                    table['libelle']]for table in datas.add_menu()]
                  ]
        data = [menu1, menu2, menu3]
        return data

    def render_scroll_menu(self, ctx, data):
        mm = ScrollMenuManager(width=180, height=35, top=2, left=15, scrollable=True)
        for menu in data:
            mm.add_menu(menu)
        return mm.render()

