# *-* coding: iso-8859-15 -*-
""" Menu déroulant """
from nevow import tags as T
from nevow.flat import flatten
from div import ScrollMenu
class ScrollMenuManager:
    """ gestionnaire de menu déroulant """

    def __init__(self, width, height, top, left, scrollable = True):
        """ initialisation du gestionnaire de menu
        :width: largeur d'un menu
        :height: hauteur d'un menus
        :top: position verticale
        :left: position horizontale
        :scrollable: notre menu doit-il suivre la page en scrollant
        """
        self.menus = []
        self.menu_count = 0
        self.width = width
        self.height = height
        self.top = top
        self.left = left
        if scrollable:
            self.scrollable = "true"
        else:
            self.scrollable = "false"

    def add_menu(self, menu):
        """ ajoute un menu au manager
        :menu: [ ['intitule du menu', 'description du menu'], [...['intitule du lien', 'lien href', 'description du lien']...] ]
        """
        self.menu_count += 1
        my_menu = ScrollMenu(menu[0][0], menu[0][1], number=self.menu_count)
        for element in menu[1]:
            my_menu.add_item(element[0], element[1], element[2])
        #my_menu = EoleMenu(menu, self.menu_count)
        self.menus.append(my_menu)

    def render(self):
        """ rend les menus """
        tag = T.div(_id="conteneurscrollMenu")
        for element in self.menus:
            tag.children.append(element)
        return [tag, self._script()]

    def _script(self):
        """ renvoit la balise script pour initialiser les menus """
        tag = T.script(_type="text/javascript")
        function = "initScrollMenu(%d, %d, %d,  %d, %d, 'H', %s);Chargement();"%(
                self.menu_count, self.width, self.height, self.top, self.left,
                self.scrollable)
        tag.children.append(function)
        return tag



class EoleMenu:
    """ renvoit un menu dont la structure le rend déroulant"""

    def __init__(self, menu, number):
        self.menu_data = menu
        self.number = number

    def _header(self):
        """ renvoit l'entete du menu """
        header = self.menu_data[0]
        title = header[1]
        text = header[0]
        tag = T.p(_id="scrollMenu%d"%self.number,
                  _class="scrollMenu",
                  onmouseover="MontrerMenu('scrollSsMenu%d');"%self.number,
                  onmouseout="CacherDelai();", title=title)[
                   T.a(href="#",
                       onmouseover="MontrerMenu('scrollSsMenu%d');"%self.number,
                       onfocus="MontrerMenu('scrollSsMenu%d');"%self.number)[
                           text
                        ]
                  ]
        return tag

    def _body(self):
        """ renvoit le corp du menu """
        body = self.menu_data[1]
        tag = T.ul(_id="scrollSsMenu%d"%self.number, _class="scrollSsMenu", onmouseover="AnnulerCacher();", onmouseout="CacherDelai();", onfocus="AnnulerCacher();", onblur="CacherDelai();")
        for item in body:
            item_tag = T.li(title=item[2])[T.a(href=item[1])[item[0]]]
            tag.children.append(item_tag)
        return tag

    def _script(self):
        """ retourne les informations pour le script d'init """
        pass

    def render(self):
        """ rend le menu """
        return [self._header(), self._body()]

    def flat(self):
        """ rend le menu flattener """
        return flatten(self.render())
