#-*-coding:utf-8-*-
""" pages spécifiques à l'application de gestion de profil posh
    Ces pages ne sont pas intégrées dans l'automtisation de l'interface
"""
from os.path import join, splitext, isdir, isfile
import commands
from nevow.rend import Page
from nevow import loaders, tags as T, inevow
from interface.interface import tools
from interface.interface.config import HTML_DIR, SCRIPT_DIR, STYLE_DIR
from interface.interface.frags.message import Message

dest_dir = "/var/www/html/posh/includes/plugins/plugin_desktop/icones/"
dest_url = "%s/posh/includes/plugins/plugin_desktop/icones/"

def test_extension(filename):
    """
    teste l'extension d'un fichier d'image
    """
    assert splitext(filename)[-1] in ('.jpg', '.png', '.ico', '.gif')

def writefile(filename, filecontent):
    """
        écrit le fichier image
    """
    f_ = file(filename, 'w')
    f_.write(filecontent)
    f_.close()
    a,b = commands.getstatusoutput("chown www-data %s" % filename)
    if a:
        return False
    return True

class ValidUpload(Message):
    close_btn_code = "window.close();"

    def locateChild(self, ctx, segments):
        return self, ()

    def data_message(self, ctx, data):
        """ renvoie le message de retour de téléchargement de fichier
        """
        request = inevow.IRequest(ctx)
        if request.args.has_key('uploadfile'):
            filecontent = request.args['uploadfile'][0]
            if request.args.has_key('filename'):
                filename = request.args['filename'][0].split('/')[-1]
                filename = filename.split('\\')[-1]
        if not request.args.has_key('filename') or not request.args.has_key('uploadfile'):
            return dict(message=[{'libelle':"Erreur: pas de fichier télécharger"}], alert="_error")
        try:
            test_extension(filename)
        except AssertionError:
            return {'message':['Erreur: mauvais type de fichier'], 'alert':'_error'}
        if isdir(dest_dir):
            if not isfile(join(dest_dir, filename)):
                if writefile(join(dest_dir, filename), filecontent):
                    root_url_without_port = tools._get_root_url_without_port(ctx)
                    access_url = join(dest_url, filename) % root_url_without_port
                    message = {'libelle':"L'image a bien été téléchargée, l'url d'accès est : %s" % access_url, 'font':'bold'}
                    return dict(message=[message], alert="")
                else:
                    message = {'libelle':"Erreur à l'acriture de l'image", "font":"bold"}
                    return dict(message=[message], alert="_error")
        return dict(message=["Erreur"], alert="_error")


class IconeUpload(Page):
    docFactory = loaders.xmlfile(join(HTML_DIR, 'iconeupload.xml'))
    children = {'valid':ValidUpload()}
    myurl = ['icone']
    valid_url = ['icone', 'valid']

    def locateChild(self, ctx, segments):
        request = inevow.IRequest(ctx)
        child, remainingSegments = Page.locateChild(self, ctx, segments)
        if child:
            return child, remainingSegments
        return self, ()

    def data_js_scripts(self, ctx, data):
        """
            rend les imports de javascript
        """
        return [{'name':join('/scripts', js_file)}for js_file in tools.get_js_file_list(SCRIPT_DIR)]

    def data_css(self, ctx, data):
        """
            renvoie les paths vers les css à importer
        """
        return [{'name':join('/style', css_file)}for css_file in tools.get_css_file_list(STYLE_DIR)]


    def render_icon(self, ctx, data):
        return T.link(_type="image/x-icon", href="/image/eole_icone.ico", rel="shortcut icon")

    def render_title(self, ctx, data):
        """ renvoie le titre de la page
        """
        return T.title["Téléchargement d'icône"]

    def render_input(self, ctx, data):
        """ rend l'input de téléchargement
        """
        return [T.input(_type='file', name='uploadfile', id="img_file",
                        onchange="$('filename').value=this.value;"),
               T.input(_type="hidden", name="filename", _id="filename")]

    def render_attr_slots(self, ctx, data):
        """rend les attributs remplissant les 'slots' du template
        """
        ctx.fillSlots('valid_url', join(tools._get_root_url(ctx),
                                        *self.valid_url))
        return ctx.tag
