# -*- coding: utf-8 -*-
"""
    outil pour l'interface d'administration html des profils du portail
    posh-portaneo version Eole
"""
from os import listdir
from os.path import splitext, join
from nevow.url import URL

def get_js_file_list(SCRIPT_DIR):
    """ renvoie la liste des fichiers javascript disponibles dans le repertoire
    """
    ret = [f_name for f_name in listdir(SCRIPT_DIR) if splitext(f_name)[-1] == '.js']
    ret.sort()
    return ret

def get_css_file_list(STYLE_DIR):
    """ renvoie la liste des feuilles de style disponibles dans le repertoire
    """
    ret = [f_name for f_name in listdir(STYLE_DIR) if splitext(f_name)[-1] == '.css']
    ret.sort()
    return ret

def _get_root_url(ctx):
    """ renvoie l'url de base de l'application à partir de l'url utilisée
        par le client pour se connecter
    """
    url_obj = URL.fromContext(ctx)
    return "%s://%s" % (url_obj.scheme, url_obj.netloc)

def _get_root_url_without_port(ctx):
    return ':'.join(_get_root_url(ctx).split(':')[0:-1])
